---
- name: "Switchover R/W traffic to the new Patroni Cluster (logical replication mode)"
  hosts: 'source_cluster:target_cluster:pgbouncer:pgbouncer_sidekiq'
  gather_facts: true
  become: true
  become_user: "{{ os_pg_user }}"
  any_errors_fatal: true
  vars:
    non_interactive: false  # if 'true', no confirmation will be requested before performing the switchver.
  pre_tasks:
    # Preparation
    - name: "[Prepare] Ensure the Chef client is stopped (to prevent unexpected changes during the switchover)"
      become: true
      become_user: root
      command: chef-client-disable "Switchover the traffic to the new Patroni Cluster"
      when:
        - (inventory_hostname in groups['source_cluster'] or
           inventory_hostname in groups['target_cluster'])

    - name: '[Prepare] Set the variable: allowed_max_replication_lag_bytes'
      set_fact:
        allowed_max_replication_lag_bytes: "{{ force_mode_max_replication_lag_bytes if force_mode | bool else max_replication_lag_bytes }}"
      when:
        - inventory_hostname in groups['source_cluster']

    - name: '[Prepare] Set the variables: source and target patroni consul service names'
      set_fact:
        source_patroni_consul_service_name: "{{ hostvars[groups['source_cluster'][0]]\
        ['patroni_consul_service_name'][cluster_environment][cluster_suffix] }}"
        target_patroni_consul_service_name: "{{ hostvars[groups['target_cluster'][0]]\
        ['patroni_consul_service_name'][cluster_environment][cluster_suffix] }}"
        source_patroni_consul_service_rename_to: "{{ hostvars[groups['source_cluster'][0]]\
        ['patroni_consul_service_name'][cluster_environment][cluster_suffix] + '-old' }}"
        target_patroni_consul_service_rename_to: "{{ hostvars[groups['source_cluster'][0]]\
        ['patroni_consul_service_name'][cluster_environment][cluster_suffix] }}"
      when:
        - (inventory_hostname in groups['source_cluster'] or
           inventory_hostname in groups['target_cluster'])

    - name: '[Prepare] Get Patroni Cluster Name'
      uri:
        url: http://{{ inventory_hostname }}:{{ patroni_restapi_port }}/patroni
      register: patroni_result
      changed_when: false
      when:
        - (inventory_hostname in groups['source_cluster'] or
           inventory_hostname in groups['target_cluster'])

    - name: '[Prepare] Set the variable: patroni_cluster_name'
      set_fact:
        patroni_cluster_name: "{{ patroni_result.json.patroni.scope }}"
      when:
        - (inventory_hostname in groups['source_cluster'] or
           inventory_hostname in groups['target_cluster'])

    - name: '[Prepare] Get Patroni Cluster Leader Node'
      uri:
        url: http://{{ inventory_hostname }}:{{ patroni_restapi_port }}/leader
        status_code: 200
      register: patroni_leader_result
      changed_when: false
      failed_when: false
      when:
        - (inventory_hostname in groups['source_cluster'] or
           inventory_hostname in groups['target_cluster'])

    - name: '[Prepare] Set the variable: patroni_cluster_leader: true'
      set_fact:
        patroni_cluster_leader: true
      when:
        - (inventory_hostname in groups['source_cluster'] or
           inventory_hostname in groups['target_cluster'])
        - patroni_leader_result.status == 200

    - name: '[Prepare] Set the variable: patroni_cluster_leader: false'
      set_fact:
        patroni_cluster_leader: false
      when:
        - (inventory_hostname in groups['source_cluster'] or
           inventory_hostname in groups['target_cluster'])
        - patroni_leader_result.status != 200

    - name: '[Prepare] Add host to group "source_primary" (in-memory inventory)'
      add_host:
        name: "{{ item }}"
        groups: source_primary
      when: hostvars[item]['patroni_cluster_leader']
      loop: "{{ groups['source_cluster'] }}"
      changed_when: false

    - name: '[Prepare] Add host to group "target_primary" (in-memory inventory)'
      add_host:
        name: "{{ item }}"
        groups: target_primary
      when: hostvars[item]['patroni_cluster_leader']
      loop: "{{ groups['target_cluster'] }}"
      changed_when: false

    - name: "Print Source Patroni Cluster Leader"
      debug:
        msg: "Source Cluster Leader: {{ inventory_hostname }}"
      when:
        - inventory_hostname in groups['source_cluster']
        - patroni_cluster_leader

    - name: "Print Target Patroni Cluster Leader"
      debug:
        msg: "Target Cluster Leader: {{ inventory_hostname }}"
      when:
        - inventory_hostname in groups['target_cluster']
        - patroni_cluster_leader

    - name: "Print Consul Service Name"
      debug:
        msg:
          - "Leader Consul Service name:
            master.{{ source_patroni_consul_service_name }}.service.consul"
      when:
        - inventory_hostname in groups['source_cluster']
        - patroni_cluster_leader

    - name: "Get list of master service node"
      command: "dig @localhost -p 8600 +short \
        master.{{ source_patroni_consul_service_name }}.service.consul SRV"
      register: consul_service_node_master_result
      changed_when: false
      run_once: true
      when:
        - inventory_hostname in groups['source_cluster']

    - name: "Print list of master service node"
      debug:
        msg: "{{ consul_service_node_master_result.stdout_lines }}"
      run_once: true
      when:
        - inventory_hostname in groups['source_cluster']
        - consul_service_node_master_result.stdout_lines is defined
  tags: always

  # Perform Pre-Checks before switching traffic
  ####################################################################
  tasks:
    # One replication slot (if pg_publication_count = 1)
    - block:
        - name: '[Pre-Check] (SOURCE) Make sure that logical replication is active'
          command: >-
            gitlab-psql -tAXc "select active from pg_replication_slots
            where slot_name = '{{ pg_source_logical_slot_name }}'"
          register: rw_pg_logical_slot_state
          changed_when: false

        # Stop, if there is no replication slot with the name specified in the pg_source_logical_slot_name variable
        - name: "(SOURCE) Print logical replication state"
          fail:
            msg: There is no replication slot with the name "{{ pg_source_logical_slot_name }}"
          when:
            - rw_pg_logical_slot_state.stdout | length < 1

        # Stop, if t he replication slot pg_source_logical_slot_name is not active
        - name: "(SOURCE) Print logical replication state"
          fail:
            msg: The replication slot "{{ pg_source_logical_slot_name }}" is not active
          when:
            - rw_pg_logical_slot_state.stdout | length > 0
            - rw_pg_logical_slot_state.stdout != "t"

        - name: "[Pre-Check] (SOURCE) Make sure there is no high logical replication lag (more than {{ allowed_max_replication_lag_bytes | int | human_readable }})"
          command: >-
            gitlab-psql -tAXc "select pg_wal_lsn_diff(pg_current_wal_lsn(), confirmed_flush_lsn)
            from pg_replication_slots where slot_name = '{{ pg_source_logical_slot_name }}'"
          register: rw_pg_logical_slot_lag_bytes
          changed_when: false
          failed_when: false
          until: rw_pg_logical_slot_lag_bytes.stdout|int < allowed_max_replication_lag_bytes|int
          retries: 30  # 1 minute
          delay: 2

        - block:  # Stop if the replication lag is high
            - name: "(SOURCE) Print logical replication lag"
              debug:
                msg: "Current logical replication lag:
                  {{ rw_pg_logical_slot_lag_bytes.stdout | int | human_readable }}"

            - name: "Pre-Check error. Please try again later"
              fail:
                msg: High logical replication lag, please try again later.
          when:
            - rw_pg_logical_slot_lag_bytes.stdout is defined
            - rw_pg_logical_slot_lag_bytes.stdout|int >= allowed_max_replication_lag_bytes|int
      when:
        - pg_publication_count | int == 1
        - inventory_hostname in groups['source_cluster']
        - patroni_cluster_leader

    # Multiple replication slots (if pg_publication_count > 1)
    - block:
        - name: '[Pre-Check] (SOURCE) Make sure that logical replication is active for each slot'
          command: >-
            gitlab-psql -tAXc "select active from pg_replication_slots
            where slot_name = '{{ pg_source_logical_slot_name }}_{{ '%02d' % (idx + 1) }}'"
          register: rw_pg_logical_multi_slot_state
          changed_when: false
          loop: "{{ range(0, pg_publication_count | int) | list }}"
          loop_control:
            index_var: idx
            label: "{{ pg_target_subscription_name }}_{{ '%02d' % (idx + 1) }}"

        # Stop, if there is no replication slot with the name specified in the pg_source_logical_slot_name variable
        - name: "(SOURCE) Print logical replication state for each slot"
          fail:
            msg: There is no replication slot with the name "{{ pg_source_logical_slot_name }}_{{ '%02d' % (idx + 1) }}"
          loop: "{{ range(0, pg_publication_count | int) | list }}"
          loop_control:
            index_var: idx
            label: "{{ pg_target_subscription_name }}_{{ '%02d' % (idx + 1) }}"
          when:
            - rw_pg_logical_multi_slot_state.results[idx].stdout | length < 1

        # Stop, if the replication slot pg_source_logical_slot_name is not active
        - name: "(SOURCE) Print logical replication state for each slot"
          fail:
            msg: The replication slot "{{ pg_source_logical_slot_name }}_{{ '%02d' % (idx + 1) }}" is not active
          loop: "{{ range(0, pg_publication_count | int) | list }}"
          loop_control:
            index_var: idx
            label: "{{ pg_target_subscription_name }}_{{ '%02d' % (idx + 1) }}"
          when:
            - rw_pg_logical_multi_slot_state.results[idx].stdout | length > 0
            - rw_pg_logical_multi_slot_state.results[idx].stdout != "t"

        - name: "[Pre-Check] (SOURCE) Make sure there is no high logical replication lag (more than {{ allowed_max_replication_lag_bytes | int | human_readable }})"
          command: >-
            gitlab-psql -tAXc "select pg_wal_lsn_diff(pg_current_wal_lsn(), confirmed_flush_lsn)
            from pg_replication_slots where slot_name like '{{ pg_source_logical_slot_name }}%'
            order by 1 desc limit 1"
          register: rw_pg_logical_multi_slot_lag_bytes
          changed_when: false
          failed_when: false
          until: rw_pg_logical_multi_slot_lag_bytes.stdout|int < allowed_max_replication_lag_bytes|int
          retries: 30  # 1 minute
          delay: 2

        - block:  # Stop if the replication lag is high
            - name: "(SOURCE) Print logical replication lag"
              debug:
                msg: "Current logical replication lag:
                  {{ rw_max_slot_lag_bytes | int | human_readable }}"

            - name: "Pre-Check error. Please try again later"
              fail:
                msg: High logical replication lag, please try again later.
          when:
            - rw_pg_logical_multi_slot_lag_bytes.stdout is defined
            - rw_pg_logical_multi_slot_lag_bytes.stdout|int >= allowed_max_replication_lag_bytes|int
      when:
        - pg_publication_count | int > 1
        - inventory_hostname in groups['source_cluster']
        - patroni_cluster_leader

    - name: '[Pre-Check] (SOURCE) Make sure there are no long-running transactions (more than {{ max_transaction_sec }} seconds)'
      command: >-
        gitlab-psql -tAXc "select pid, usename, client_addr, clock_timestamp() - xact_start as xact_age,
          state, wait_event_type ||':'|| wait_event as wait_events,
          left(regexp_replace(query, E'[ \\t\\n\\r]+', ' ', 'g'),100) as query
          from pg_stat_activity
          where clock_timestamp() - xact_start > '{{ max_transaction_sec }} seconds'::interval
          and backend_type = 'client backend' and pid <> pg_backend_pid()
          order by xact_age desc limit 10"
      register: pg_long_transactions
      changed_when: false
      failed_when: false
      until: pg_long_transactions.stdout | length < 1
      retries: 30  # 1 minute
      delay: 2
      when:
        - inventory_hostname in groups['source_cluster']
        - patroni_cluster_leader
        - not force_mode | bool  # skip if force_mode is true

    # Stop if long-running transactions are detected (if force_mode: false)
    - block:
        - name: "(SOURCE) Print long-running (>{{ max_transaction_sec }}s) transactions"
          debug:
            msg: "{{ pg_long_transactions.stdout_lines }}"

        - name: "Pre-Check error. Please try again later"
          fail:
            msg: long-running transactions detected (more than {{ max_transaction_sec }} seconds), please try again later.
      when:
        - inventory_hostname in groups['source_cluster']
        - patroni_cluster_leader
        - pg_long_transactions.stdout is defined
        - pg_long_transactions.stdout | length > 0

    # Switchover
    ####################################################################

    # Request confirmation (if 'non_interactive' is 'false')
    - block:
        - name: Perform switchover traffic to the leader of the new cluster?
          pause:
            prompt: "Are you sure you want to switch traffic to the leader of the new cluster? [y/N]"
          delegate_to: "{{ groups['source_cluster'][0] }}"
          register: prompt_result

        - name: "Set the variable: ask_result_leader"
          set_fact:
            ask_result_leader: "{{ hostvars[groups['source_cluster'][0]]['prompt_result']['user_input'] }}"
      when:
        - not non_interactive | bool

    # if 'enable_reverse_logical_replication' is 'true' and 'pg_publication_count_reverse' > 1
    - block:
        # Split tables (sorted by DML operations) into groups for publications for reverse logical replication
        - name: "(SOURCE) Get a list of tables distributed by groups (for reverse logical replication)"
          shell: |
            gitlab-psql -d {{ pg_source_dbname }} -tAXc "
            do \$$
            declare
              num_groups constant int := {{ pg_publication_count_reverse }};
              group_weights bigint[] := array_fill(0, array[num_groups]);
              random_group_index int;
              lowest_weight_index int;
              lowest_weight bigint;
              table_rec record;
            begin
              create temp table tables_groups_tmp_zx7d2r1dbzfu (
                group_id int,
                table_name text,
                weight bigint,
                total_weight bigint
              );

              for table_rec in
                select
                  format('\\\"%I\\\".\\\"%I\\\"', schemaname, relname) as table_name,
                  n_tup_ins + n_tup_upd + n_tup_del as weight
                from pg_stat_user_tables
                where relname <> 'tables_groups_tmp_zx7d2r1dbzfu'
                  and not exists (
                    select 1
                    from pg_class
                    where oid = pg_stat_user_tables.relid
                      and (relkind = 'p' or relid in (select inhparent from pg_inherits))
                  )  -- Exclude parent tables for both declarative and inheritance-based partitioning
                order by weight desc
              loop
                -- for tables with a weight > 0, we find the group with the lowest total weight
                if table_rec.weight > 0 then
                  lowest_weight_index := 1;
                  lowest_weight := group_weights[1];
                  for i in 2..num_groups loop
                    if group_weights[i] < lowest_weight then
                      lowest_weight_index := i;
                      lowest_weight := group_weights[i];
                    end if;
                  end loop;
                -- for tables with a weight = 0, randomly select a group
                else
                  random_group_index := (trunc(random() * num_groups) + 1)::int;
                  lowest_weight_index := random_group_index;
                end if;

                group_weights[lowest_weight_index] := group_weights[lowest_weight_index] + table_rec.weight;

                insert into tables_groups_tmp_zx7d2r1dbzfu (group_id, table_name, weight, total_weight)
                values (lowest_weight_index, table_rec.table_name, table_rec.weight, group_weights[lowest_weight_index]);
              end loop;
            end \$$;

            -- get a list of tables distributed by groups
            select
              string_agg(table_name, ',') as tables
            from tables_groups_tmp_zx7d2r1dbzfu
            group by group_id
            order by group_id;"
          args:
            executable: /bin/bash
          delegate_to: "{{ groups.source_primary[0] }}"  # Get tables groups from the Source cluster
          register: tables_groups
      when:
        - enable_reverse_logical_replication | bool
        - pg_publication_count_reverse | int > 1
        - inventory_hostname in groups['target_cluster']
        - patroni_cluster_leader

    # Sequences
    - name: "(SOURCE) Get the value of sequences"
      command: >-
        gitlab-psql -d {{ pg_source_dbname }} -tAXc "
        select json_agg(json_build_object(
        'schemaname', schemaname,
        'sequencename', sequencename,
        'last_value', coalesce(last_value, 1))
        order by schemaname, sequencename)
        from pg_sequences"
      register: pg_sequences
      changed_when: false
      when:
        - inventory_hostname in groups['source_cluster']
        - patroni_cluster_leader
        - (ask_result_leader is defined and ask_result_leader == "y" or non_interactive | bool)

    - name: (TARGET) Generate the file "pg_sequences_increase.sql"
      copy:
        content: |
          with unpacked(j_val) as (
            select json_array_elements('{{ hostvars[groups['source_primary'][0]]['pg_sequences']['stdout'] }}'::json)
          )
          select
            setval(
              format(
                '%I.%I',
                j_val->>'schemaname',
                j_val->>'sequencename'
              )::regclass,
              (j_val->>'last_value')::bigint + {{ pg_sequences_increase_value }}
            )
          from unpacked;
        dest: /tmp/pg_sequences_increase_{{ ansible_date_time.date }}.sql
      when:
        - inventory_hostname in groups['target_cluster']
        - patroni_cluster_leader
        - (ask_result_leader is defined and ask_result_leader == "y" or non_interactive | bool)

    # in the new cluster, add +N to the current value of the sequences received from the old cluster
    - name: "(TARGET) Increase the value of sequences. Add +{{ pg_sequences_increase_value }} to the current value of the sequences of the old cluster"
      command: gitlab-psql -d {{ pg_source_dbname }} -f /tmp/pg_sequences_increase_{{ ansible_date_time.date }}.sql
      when:
        - inventory_hostname in groups['target_cluster']
        - patroni_cluster_leader
        - (ask_result_leader is defined and ask_result_leader == "y" or non_interactive | bool)

    # Re-check the lag of logical replication before switchover
    - block:
        # We will wait here until we find the right opportunity (logical replication lag is 0 bytes) before we even perform the switchover.
        - name: "(SOURCE) Attempt to wait for the window without logical replication lag before switchover (max wait time: {{ before_switchover_no_lag_window_timeout }} seconds)"
          command: >-
            gitlab-psql -tAXc "select pg_wal_lsn_diff(pg_current_wal_lsn(), confirmed_flush_lsn)
            from pg_replication_slots where slot_name like '{{ pg_source_logical_slot_name }}%'
            order by 1 desc limit 1"
          register: pg_logical_slot_lag_bytes_before_pause
          changed_when: false
          failed_when: false
          until: pg_logical_slot_lag_bytes_before_pause.stdout|int == 0
          retries: "{{ before_switchover_no_lag_window_timeout | int }}"  # max wait time: 5 minutes
          delay: 1

        # If the lag is more than 0 bytes, but less than the allowed one, continue switchover.
        # Else, stop if the replication lag is high (more than 'allowed_max_replication_lag_bytes')
        - block:
            - name: "(SOURCE) Print logical replication lag"
              debug:
                msg: "Current logical replication lag:
                  {{ pg_logical_slot_lag_bytes_before_pause.stdout | int | human_readable }}"

            - name: "Pre-Check error. Please try again later"
              fail:
                msg: High logical replication lag, please try again later.
          when:
            - pg_logical_slot_lag_bytes_before_pause.stdout is defined
            - pg_logical_slot_lag_bytes_before_pause.stdout|int >= allowed_max_replication_lag_bytes|int
      when:
        - inventory_hostname in groups['source_cluster']
        - patroni_cluster_leader
        - (ask_result_leader is defined and ask_result_leader == "y" or non_interactive | bool)

    # Perform PAUSE in parallel on all pgbouncers servers (if force_mode: false)
    #
    # This script performs the following actions:
    # 1. Waits for active database queries on the pg_server to complete.
    # 2. If there are no active queries, sends a PAUSE command to each pgbouncer server in the pgb_servers list (in parallel to all servers).
    # 3. If all pgbouncer servers are successfully paused, the script exits.
    # 4. If active queries do not complete within 30 seconds, the script forcibly terminates slow active queries using pg_slow_active_terminate_query.
    # 5. If after that it is still not possible to pause the pgbouncer servers within 60 seconds from the start of the script, the script exits with an error.
    #
    # The script uses the pause_results array to track the results of executing the PAUSE command on each pgbouncer server.
    # The timeout 2s command is used to set a timeout for the execution of the pgb-console command.
    # If the execution of the pgb-console command does not finish within 2 seconds, the timeout command will interrupt the execution of pgb-console and execute the pgb_resume_query command to remove the pause and ensure atomicity.
    #
    # Finally, the script checks whether all servers have been successfully paused by comparing the number of successful PAUSE executions to the total number of pgbouncer servers.
    - name: "(SOURCE) PAUSE PgBouncer pools"
      become: true
      become_user: "{{ lookup('env', 'USER') }}"
      shell: |
        pgb_servers="{{ (groups['pgbouncer'] + groups['pgbouncer_sidekiq']) | join('\n') }}"
        pgb_count=$(echo -e "$pgb_servers" | wc -l)
        pg_server="{{ groups['source_primary'][0] }}"
        pg_slow_active_count_query="select count(*) from pg_stat_activity where pid <> pg_backend_pid() and backend_type = 'client backend' and state <> 'idle' and query_start < clock_timestamp() - interval '{{ pg_slow_active_query_treshold_to_analyse }} ms'"
        pg_slow_active_terminate_query="select pg_terminate_backend(pid) from pg_stat_activity where pid <> pg_backend_pid() and backend_type = 'client backend' and state <> 'idle' and query_start < clock_timestamp() - interval '{{ pg_slow_active_query_treshold_to_terminate }} ms'"

        start_time=$(date +%s)
        while true; do
          current_time=$(date +%s)
          # initialize pgb_paused_count to 0 (we assume that all pgbouncers are not paused)
          pgb_paused_count=0

          # wait for the active queries to complete on pg_server
          pg_slow_active_count=$(ssh -o StrictHostKeyChecking=no "$pg_server" "gitlab-psql -tAXc \"$pg_slow_active_count_query\"")
          echo "$(date): pg_slow_active_count: $pg_slow_active_count"

          if [[ "$pg_slow_active_count" == 0 ]]; then
            # pause pgbouncer on all pgb_servers. We send via ssh to all pgbouncers in parallel and collect results from all (maximum wait time 2 seconds)
            IFS=$'\n' pause_results=($(echo -e "$pgb_servers" | xargs -I {} -P "$pgb_count" -n 1 ssh -o StrictHostKeyChecking=no {} "timeout {{ pgbouncer_pool_pause_timeout }}s sudo pgb-console -c \"PAUSE\" 2>&1 || true"))
            echo "${pause_results[*]}"
            # analyze the pause_results array to count the number of paused pgbouncers
            pgb_paused_count=$(echo "${pause_results[*]}" | grep -o -e "PAUSE" -e "already suspended/paused" | wc -l)
            echo "$(date): pgb_count: $pgb_count, pgb_paused: $pgb_paused_count"
          fi

          # make sure that the pause is performed on all pgbouncer servers, to ensure atomicity
          if [[ "$pgb_paused_count" -eq "$pgb_count" ]]; then
            break # pause is performed on all pgb_servers, exit from the loop
          elif [[ "$pgb_paused_count" -gt 0 && "$pgb_paused_count" -ne "$pgb_count" ]]; then
            # pause is not performed on all pgb_servers, perform resume (we do not use timeout because we mast to resume all pgbouncers)
            IFS=$'\n' resume_results=($(echo -e "$pgb_servers" | xargs -I {} -P "$pgb_count" -n 1 ssh -o StrictHostKeyChecking=no {} "sudo pgb-console -c \"RESUME\" 2>&1 || true"))
            echo "${resume_results[*]}"
          fi

          # after 30 seconds of waiting, terminate active sessions and try pausing again
          if (( current_time - start_time >= {{ pgbouncer_pool_pause_terminate_after }} )); then
            pg_terminate_result=$(ssh -o StrictHostKeyChecking=no "$pg_server" "gitlab-psql -tAXc \"$pg_slow_active_terminate_query\"")
            echo "$(date): terminate active queries"
          fi

          # if it was not possible to pause for 60 seconds, exit with an error
          if (( current_time - start_time >= {{ pgbouncer_pool_pause_give_up_after }} )); then
            echo "$(date): it was not possible to pause (exit by timeout)"
            exit 1
          fi
        done > /tmp/pgbouncer_pool_pause_{{ ansible_date_time.date }}.log
      args:
        executable: /bin/bash
      register: pause_pgbouncer_pool_result
      delegate_to: localhost
      run_once: true
      when:
        - (ask_result_leader is defined and ask_result_leader == "y" or non_interactive | bool)
        - pgbouncer_pool_pause | bool
        - not force_mode | bool  # skip if force_mode is true

    # Attention!
    # During the pause, it is necessary to do as few tasks as possible,
    # since the time during which the pause depends on it, and therefore the latency of queries increases.

    # Here we make the old primary "read only", via setting `default_transaction_read_only` globally.
    # Though this is not a 100% guarantee – anyone can override this using `SET` – we don't expect (and rely on it) anyone to run `SET`
    - name: "(SOURCE) Enable read-only mode for the old cluster leader"
      command: >
        gitlab-psql -tAXc "alter system set default_transaction_read_only = 'on'"
        && gitlab-psql -tAXc "select pg_reload_conf()"
      ignore_errors: true  # ignore the errors to RESUME anyway.
      when:
        - inventory_hostname in groups['source_cluster']
        - patroni_cluster_leader
        - (ask_result_leader is defined and ask_result_leader == "y" or non_interactive | bool)
        - not enable_reverse_logical_replication | bool  # skip if reverse logical replication is enabled

    # (if force_mode: true) Terminate active sessions
    # To ensure that there are no writing transactions that can make changes to the database
    # Note: this task is not necessary if the pool is paused
    - name: "(SOURCE) Terminate active sessions on the source cluster leader"
      command: >-
        gitlab-psql -tAXc "select pg_terminate_backend(pid)
          from pg_stat_activity
          where pid <> pg_backend_pid()
          and backend_type = 'client backend'
          and state <> 'idle'"
      ignore_errors: true
      when:
        - inventory_hostname in groups['source_cluster']
        - patroni_cluster_leader
        - (ask_result_leader is defined and ask_result_leader == "y" or non_interactive | bool)
        - force_mode | bool
        - force_mode_pg_terminate | bool

    # To ensure we will have ZERO DATA LOSS during the Switchover, we will wait here to until we have a logical replication lag to zero bytes.
    # We do not want to wait here for to long too as all our PgBouncers are already PAUSED at this stage. We are waiting here for a maximum of 60 seconds.
    # If we do not get logical replication lag to zero bytes, we will NOT PERFORM the SWTICHOVER. We will troubleshoot the issue and try again.
    - name: "(SOURCE) Wait until the logical replication lag is 0 bytes"
      command: >-
        gitlab-psql -tAXc "select pg_wal_lsn_diff(pg_current_wal_lsn(), confirmed_flush_lsn)
        from pg_replication_slots where slot_name like '{{ pg_source_logical_slot_name }}%'
        order by 1 desc limit 1"
      register: pg_logical_slot_lag_bytes_after_pause
      until: pg_logical_slot_lag_bytes_after_pause.stdout|int == 0
      retries: "{{ pgbouncer_pool_pause_zero_lag_check_timeout | int }}"  # max wait time: 60 seconds
      delay: 1
      changed_when: false
      ignore_errors: true  # ignore the errors to RESUME anyway.
      when:
        - inventory_hostname in groups['source_cluster']
        - patroni_cluster_leader
        - (ask_result_leader is defined and ask_result_leader == "y" or non_interactive | bool)
        - not force_mode | bool  # skip if force_mode is true

    # Stop logical replication before switching write traffic to the new cluster leader.
    - name: "(TARGET) Stop logical replication"
      include_role:
        name: upgrade
        tasks_from: drop_subscription
      vars:
        dbname: "{{ pg_target_dbname }}"
        subscription_name: "{{ pg_target_subscription_name }}"
      ignore_errors: true  # ignore the errors to RESUME anyway.
      when:
        - inventory_hostname in groups['target_cluster']
        - patroni_cluster_leader
        - (ask_result_leader is defined and ask_result_leader == "y" or non_interactive | bool)
        - ((hostvars[groups['source_primary'][0]]['pg_logical_slot_lag_bytes_after_pause']['stdout'] | default(1) | int == 0)
          or force_mode | bool)  # only if no logical replication lag or force_mode is used

    # Here we perform the renaming of еthe consul services and the reload of the consul.service
    # in parallel on all servers on the source and target clusters, delegating the tasks to the server running the playbook.
    - name: "(SOURCE/TARGET) Stop traffic to the old cluster leader and start traffic to the new cluster leader: rename the Consul service"
      become: true
      become_user: "{{ lookup('env', 'USER') }}"
      shell: |
        source_pg_servers="{{ groups['source_cluster'] | join('\n') }}"
        source_pg_count=$(echo -e "$source_pg_servers" | wc -l)

        target_pg_servers="{{ groups['target_cluster'] | join('\n') }}"
        target_pg_count=$(echo -e "$target_pg_servers" | wc -l)

        consul_service_file="{{ patroni_consul_service_file[cluster_environment][cluster_suffix][0] }}"

        # rename the name of the consul service in the source cluster
        echo -e "$source_pg_servers" | xargs -I {} -P "$source_pg_count" -n 1 ssh -o StrictHostKeyChecking=no {} "
          sudo sed -i 's/\"name\": \"{{ source_patroni_consul_service_name }}\"/\"name\": \"{{ source_patroni_consul_service_rename_to }}\"/' {{ consul_cfg_path }}/$consul_service_file
          sudo systemctl reload consul
        "

        # rename the name of the consul service in the target cluster
        echo -e "$target_pg_servers" | xargs -I {} -P "$target_pg_count" -n 1 ssh -o StrictHostKeyChecking=no {} "
          sudo sed -i 's/\"name\": \"{{ target_patroni_consul_service_name }}\"/\"name\": \"{{ target_patroni_consul_service_rename_to }}\"/' {{ consul_cfg_path }}/$consul_service_file
          sudo systemctl reload consul
        "
      args:
        executable: /bin/bash
      delegate_to: localhost
      run_once: true
      ignore_errors: true  # ignore the errors to RESUME anyway.
      when:
        - (inventory_hostname in groups['source_cluster'] or inventory_hostname in groups['target_cluster'])
        - (ask_result_leader is defined and ask_result_leader == "y" or non_interactive | bool)
        - ((hostvars[groups['source_primary'][0]]['pg_logical_slot_lag_bytes_after_pause']['stdout'] | default(1) | int == 0)
          or force_mode | bool)  # only if no logical replication lag or force_mode is used
      tags: consul-config

    # Configure reverse logical replication (if 'enable_reverse_logical_replication' is 'true')
    - name: "(TARGET) Create publication and slot for reverse logical replication"
      include_role:
        name: upgrade
        tasks_from: reverse_publication
      ignore_errors: true  # ignore the errors to RESUME anyway.
      when:
        - enable_reverse_logical_replication | bool
        - (ask_result_leader is defined and ask_result_leader == "y" or non_interactive | bool)
        - ((hostvars[groups['source_primary'][0]]['pg_logical_slot_lag_bytes_after_pause']['stdout'] | default(1) | int == 0)
          or force_mode | bool)  # only if no logical replication lag or force_mode is used

    # (if force_mode: true) Restart pgbouncer service
    # To ensure that new connections will be routed to the new address after changing the DNS record for the consul service
    # Note: this task is not necessary if the pool is paused
    - name: "(SOURCE) Restart pgbouncer service"
      become: true
      become_user: root
      service:
        name: pgbouncer
        state: restarted
      when:
        - force_mode | bool
        - inventory_hostname in groups['pgbouncer'] or
          inventory_hostname in groups['pgbouncer_sidekiq']

    # Perform RESUME in parallel on all pgbouncers servers (if force_mode: false)
    - name: "(SOURCE) RESUME PgBouncer pools"
      become: true
      become_user: "{{ lookup('env', 'USER') }}"
      shell: |
        pgb_servers="{{ (groups['pgbouncer'] + groups['pgbouncer_sidekiq']) | join('\n') }}"
        pgb_count=$(echo -e "$pgb_servers" | wc -l)
        echo -e "$pgb_servers" | xargs -I {} -P "$pgb_count" -n 1 ssh -o StrictHostKeyChecking=no {} "sudo pgb-console -c \"RESUME\" 2>&1 || true"
      args:
        executable: /bin/bash
      delegate_to: localhost
      run_once: true
      when:
        - (ask_result_leader is defined and ask_result_leader == "y" or non_interactive | bool)
        - pgbouncer_pool_pause | bool
        - not force_mode | bool  # skip if force_mode is true

    - name: "Get list of master service node"
      command: "dig @localhost -p 8600 +short \
        master.{{ source_patroni_consul_service_name }}.service.consul SRV"
      register: consul_service_node_master_result
      changed_when: false
      run_once: true
      when:
        - inventory_hostname in groups['source_cluster']
        - (ask_result_leader is defined and ask_result_leader == "y" or non_interactive | bool)

    - name: "Print list of master service node"
      debug:
        msg: "{{ consul_service_node_master_result.stdout_lines }}"
      run_once: true
      when:
        - inventory_hostname in groups['source_cluster']
        - consul_service_node_master_result.stdout_lines is defined

    # Stop with an error if logical replication exceeds 0 bytes
    - name: "WARNING: The switchover was not performed because the logical replication lag did not reach our goal of 0 bytes."
      fail:
        msg: "Please try again. We have NOT PERFORMED SWTICHOVER because of the current logical replication lag:
              {{ pg_logical_slot_lag_bytes_after_pause.stdout | int | human_readable }}"
      when:
        - ((hostvars[groups['source_primary'][0]]['pg_logical_slot_lag_bytes_after_pause']['stdout'] | default(1) | int > 0)
          and not force_mode | bool)  # skip if force_mode is true

    # Perform tasks after switchover
    ####################################################################

    - name: '[Post-switchover] Clean up logical replication objects on the source cluster'
      include_role:
        name: upgrade
        tasks_from: drop_publication
      vars:
        dbname: "{{ pg_source_dbname }}"
        publication_name: "{{ pg_source_publication_name }}"
        logical_slot_name: "{{ pg_source_logical_slot_name }}"
      when:
        - inventory_hostname in groups['source_cluster']
        - patroni_cluster_leader
        - (ask_result_leader is defined and ask_result_leader == "y" or non_interactive | bool)

    # Drop publications replicated from the source cluster
    - name: '[Post-switchover] Clean up logical replication objects on the target cluster'
      include_role:
        name: upgrade
        tasks_from: drop_publication
      vars:
        dbname: "{{ pg_target_dbname }}"
        publication_name: "{{ pg_source_publication_name }}"
        logical_slot_name: "{{ pg_source_logical_slot_name }}"
        drop_publication_only: true
      when:
        - inventory_hostname in groups['target_cluster']
        - patroni_cluster_leader
        - (ask_result_leader is defined and ask_result_leader == "y" or non_interactive | bool)

    # Configure reverse logical replication (if 'enable_reverse_logical_replication' is 'true')
    - name: "(SOURCE) Start reverse logical replication"
      include_role:
        name: upgrade
        tasks_from: reverse_subscription
      when:
        - enable_reverse_logical_replication | bool
        - (ask_result_leader is defined and ask_result_leader == "y" or non_interactive | bool)

    # Pause Patroni on the Source cluster (old database)
    - name: "(SOURCE) Pause Patroni on the Source Cluster (disable auto failover)"
      become: true
      become_user: "{{ os_pg_user }}"
      command: "gitlab-patronictl pause --wait {{ patroni_cluster_name }}"
      ignore_errors: true  # show the error and continue the playbook execution
      when:
        - enable_reverse_logical_replication | bool
        - inventory_hostname in groups['source_cluster']
        - patroni_cluster_leader
        - (ask_result_leader is defined and ask_result_leader == "y" or non_interactive | bool)

    # Deny access to the old database to avoid the risks of making unwanted changes to the old database after the switchover.
    # allow only local connections (as superuser only), and replication connections to keep physical and logical replication in active state.
    - block:
        - name: "(SOURCE) Backup original hba file"
          copy:
            src: "{{ pg_old_datadir }}/pg_hba.conf"
            dest: "{{ pg_old_datadir }}/pg_hba.conf.bkp"
            remote_src: true

        - name: "(SOURCE) Deny access: replace hba file (to avoid the risks of making unwanted changes)"
          ansible.builtin.copy:
            content: |
              local all {{ patroni_superuser_username }} md5
              local replication {{ patroni_replication_username }} md5
              host replication {{ patroni_replication_username }} 127.0.0.1/32 md5
              host replication {{ patroni_replication_username }} 10.0.0.0/8 md5
              host replication {{ patroni_superuser_username }} 10.0.0.0/8 md5
              host all {{ patroni_superuser_username }} 127.0.0.1/32 md5
              host all all 0.0.0.0/0 reject
            dest: "{{ pg_old_datadir }}/pg_hba.conf"
            owner: "{{ os_pg_user }}"
            group: "{{ os_pg_user }}"
            mode: "0640"

        - name: "(SOURCE) Deny access to the old database: Reload Postgres to apply changes"
          command: gitlab-psql -tAXc "select pg_reload_conf()"
      when:
        - inventory_hostname in groups['source_cluster']
        - (ask_result_leader is defined and ask_result_leader == "y" or non_interactive | bool)
      tags: pg_hba

    - name: Switchover completed
      run_once: true
      debug:
        msg: "The witchover R/W traffic to the new Patroni Cluster has been completed."

...
